include get.e
include sort.e
without warning

integer l,d,xa,ya,e,f,fn,quit,eof,letters,sqroot,
      max_try,too_small,list_try,ss,word_fit,
      list_fit,fit,want_to_continue,
      use_this_list,max_list_try
sequence filename,wordlist,s,crossword
object g
atom word
constant FALSE=0, TRUE=1

quit=FALSE
letters=0
sqroot=0
max_try=100
want_to_continue=TRUE
max_list_try=10

function sort_by_size(sequence list)
    sequence swap
    for k=1 to length(list)-1 do
      for j=1 to length(list)-1 do
	if length(list[j])<length(list[j+1]) then
	  swap=list[j]
	  list[j]=list[j+1]
	  list[j+1]=swap
	end if
      end for
    end for
    return list
end function

procedure get_word_list()
  filename=prompt_string("What is the name of the file that contains the list of words? ")
  fn=open(filename,"r")
  if fn=-1 then
    printf(1,"The file: %s doesn't exist!",{filename})
    abort(1)
  end if
  clear_screen()
  wordlist={}
  eof=FALSE
  while eof=FALSE do
    g=gets(fn)
    if atom(g) then
      eof=1
    else
      s={}
      for k=1 to length(g) do
      if g[k]>32 then --get rid of spaces, tabs, etc.
	if g[k]>96 then g[k]-=32 end if --make only capital letters
	s=append(s,g[k])
      end if
      end for
      if length(s)>1 then
      wordlist=append(wordlist,s)
      letters+=length(s)
      end if
    end if
  end while
  close(fn)
end procedure

procedure print_crossword()
  fn=open(filename,"w")
  if fn=-1 then
    printf(1,"The file: %s doesn't exist!",{filename})
    abort(1)
  end if
  for a=1 to sqroot do
      for b=1 to sqroot do
	  if compare(crossword[a][b],".")=0 then
	    crossword[a][b]=rand(26)+64
	  end if
	  printf(fn," %s",{crossword[a][b]})
      end for puts(fn,"\n")
  end for
  puts(fn,"\n")
  for k=1 to length(wordlist) do
    printf(fn,"%s\n",{wordlist[k]})
  end for
  close(fn)
end procedure

function put_word()
  position(23,1) puts(1,"                                       ")
  position(23,1) printf(1,"%s %3d    ",{wordlist[word],list_try})
  l=length(wordlist[word])
--pick a random place and a random direction
  d=rand(8)
  xa=rand(sqroot)
  ya=rand(sqroot)
  if d=1 then e=0  f=1  end if
  if d=2 then e=-1 f=1  end if
  if d=3 then e=-1 f=0  end if
  if d=4 then e=-1 f=-1 end if
  if d=5 then e=0  f=-1 end if
  if d=6 then e=1  f=-1 end if
  if d=7 then e=1  f=0  end if
  if d=8 then e=1  f=1  end if
--while this word extends beyond the matrix - slide back until it fits
  while ya+l*f>sqroot do ya-=f end while
  while ya+l*f<1 do ya-=f end while
  while xa+l*e>sqroot do xa-=e end while
  while xa+l*e<1 do xa-=e end while
--check if all letters of this word can fit in the matrix
  fit=TRUE
  for k=1 to l do
    ss=wordlist[word][k]
    if compare(crossword[xa+k*e][ya+k*f],".")!=0 then
      if compare(crossword[xa+k*e][ya+k*f],wordlist[word][k])!=0 then
	fit=FALSE
      end if
    end if
  end for
  return(fit)
end function

function put_list()
  word=1
  list_try=0
  while word<length(wordlist) and list_try<max_try do
    word_fit=put_word()  --  will return TRUE or FALSE
    if word_fit=FALSE then
      list_try+=1
    else  --  the word fit
      for k=1 to length(wordlist[word]) do
	crossword[xa+k*e][ya+k*f]=wordlist[word][k]
      end for
      for j=1 to sqroot do
	for n=1 to sqroot do
	  if j<23 and n<40 then
	     position(j,2*n) puts(1,crossword[j][n])
	  end if
	end for
      end for
      word+=1
      list_try=0
    end if
  end while
  if list_try>=max_try then
    return(FALSE)
  else
    return(TRUE)
  end if
end function

procedure make_new_matrix()
  sqroot+=1
  crossword=repeat(repeat(".",sqroot),sqroot)
  g=get_key() clear_screen()
  if g=27 then
      abort(1)
  end if
end procedure

procedure make_crossword()
  sqroot=floor(sqrt(letters))-1 --quess at the size of the matrix needed
  if length(wordlist[1])>sqroot then
    sqroot=length(wordlist[1]) --must be at least big enough for the longest word
  end if
  list_fit=0
  too_small=FALSE
  make_new_matrix()
  while too_small=FALSE do
    too_small=put_list()  --  will return TRUE or FALSE
    if too_small=FALSE then
      list_fit+=1
      sqroot-=1
      make_new_matrix()
    end if
    if list_fit>max_list_try then
      make_new_matrix()
      list_fit=0
    end if
  end while
end procedure

function get_want_to_continue()
  position(24,1)
  g=prompt_string("Do you want to make another crostic with ANOTHER list-file (Y/N)? ")
  if equal(g,"Y") or equal(g,"y") then
    return TRUE
  else
    return FALSE
  end if
end function

function get_use_this_list()
  position(24,1)
  g=prompt_string("Do you want to make another crostic with THIS list (Y/N)? ")
  if equal(g,"N") or equal(g,"n") then
    return FALSE
  else
    return TRUE
  end if
end function

while want_to_continue=TRUE do
  use_this_list=TRUE
  get_word_list()
  if length(wordlist)>100 then max_try=length(wordlist) end if
  while use_this_list=TRUE do
    wordlist=sort_by_size(wordlist)
    make_crossword()
    wordlist=sort(wordlist)
    print_crossword()
    use_this_list=get_use_this_list()
  end while
  want_to_continue=get_want_to_continue()
end while

